diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/ArmorBag.java b/game/core/src/main/java/net/minecraft/core/entity/monster/ArmorBag.java
new file mode 100644
index 000000000..085a3175d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/ArmorBag.java
@@ -0,0 +1,90 @@
+package net.minecraft.core.entity.monster;
+
+import net.minecraft.core.enums.IArmorShape;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemArmor;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Random;
+
+public class ArmorBag<T extends IArmorShape> {
+    private class ArmorBagEntry {
+        public final @Nullable ItemArmor<T> armorItem;
+        public final int chance;
+        public final float maxHeight;
+
+        public ArmorBagEntry(final @Nullable ItemArmor<T> armorItem, final int chance, final float maxHeight) {
+            this.armorItem = armorItem;
+            this.chance = chance;
+            this.maxHeight = maxHeight;
+        }
+    }
+
+    private final @NotNull List<@NotNull ArmorBagEntry> entries = new ArrayList<>();
+
+    private final @NotNull T armorShape;
+
+    public ArmorBag(final @NotNull T armorShape) {
+        this.armorShape = armorShape;
+    }
+
+    public @NotNull T getArmorShape() {
+        return this.armorShape;
+    }
+
+    public @NotNull ArmorBag<T> addEntry(final @Nullable Item item, final int chance, final float maxHeight) {
+        if (item != null && !(item instanceof ItemArmor<?>)) {
+            throw new IllegalArgumentException("Illegal non-armor item for bag!");
+        }
+        final @Nullable ItemArmor<T> armorItem = (ItemArmor<T>) item;
+
+        if (armorItem != null && this.armorShape != armorItem.getArmorShape()) {
+            throw new IllegalArgumentException("Illegal armor item shape for bag!");
+        }
+        if (chance == 0) {
+            throw new IllegalArgumentException("Item chance cannot be 0!");
+        }
+        if (maxHeight == 0) {
+            throw new IllegalArgumentException("Max height for item cannot be 0!");
+        }
+
+        this.entries.add(new ArmorBagEntry(armorItem, chance, maxHeight));
+
+        return this;
+    }
+
+    public @Nullable ItemArmor<T> getRandomItem(final @NotNull Random rand, final int worldHeight, final int mobHeight) {
+        if (this.entries.isEmpty()) {
+            throw new RuntimeException("Tried to pull armor item from empty bag!");
+        }
+
+        final float mobHeightPercentage = (float) mobHeight / (float) worldHeight;
+
+        int sum = 0;
+        for (final @NotNull ArmorBagEntry entry : this.entries) {
+            if (mobHeightPercentage < entry.maxHeight) {
+                sum += entry.chance;
+            }
+        }
+        if (sum == 0) {
+            return null;
+        }
+
+        final int randVal = rand.nextInt(sum);
+
+        int randSum = 0;
+        for (final @NotNull ArmorBagEntry entry : this.entries) {
+            if (mobHeightPercentage < entry.maxHeight) {
+                randSum += entry.chance;
+                if (randVal < randSum) {
+                    return entry.armorItem;
+                }
+            }
+        }
+
+        throw new IllegalStateException("Should never not find an item in the bag!");
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/ArmorBags.java b/game/core/src/main/java/net/minecraft/core/entity/monster/ArmorBags.java
new file mode 100644
index 000000000..6296e9515
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/ArmorBags.java
@@ -0,0 +1,82 @@
+package net.minecraft.core.entity.monster;
+
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.enums.IArmorShape;
+import net.minecraft.core.item.Items;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.HashMap;
+
+public abstract class ArmorBags {
+    public static final @NotNull HashMap<Class<? extends MobMonsterArmored<?>>, HashMap<?, ArmorBag<?>>> ARMOR_BAGS = new HashMap<>();
+
+    public static final @NotNull HashMap<@NotNull HumanArmorShape, @NotNull ArmorBag<@NotNull HumanArmorShape>> ZOMBIE_ARMOR_BAGS = register(MobZombie.class, new HashMap<>());
+    static {
+        ZOMBIE_ARMOR_BAGS.put(HumanArmorShape.HEAD,
+                new ArmorBag<>(HumanArmorShape.HEAD)
+                        .addEntry(null, 100, 1.0f)
+                        .addEntry(Items.ARMOR_HELMET_LEATHER, 30, 0.8f)
+                        .addEntry(Items.ARMOR_HELMET_IRON, 10, 0.5f)
+                        .addEntry(Items.ARMOR_HELMET_DIAMOND, 5, 0.125f)
+                        .addEntry(Items.ARMOR_HELMET_STEEL, 1, 0.125f));
+        ZOMBIE_ARMOR_BAGS.put(HumanArmorShape.CHEST,
+                new ArmorBag<>(HumanArmorShape.CHEST)
+                        .addEntry(null, 100, 1.0f)
+                        .addEntry(Items.ARMOR_CHESTPLATE_LEATHER, 30, 0.8f)
+                        .addEntry(Items.ARMOR_CHESTPLATE_IRON, 10, 0.5f)
+                        .addEntry(Items.ARMOR_CHESTPLATE_DIAMOND, 5, 0.125f)
+                        .addEntry(Items.ARMOR_CHESTPLATE_STEEL, 1, 0.125f));
+        ZOMBIE_ARMOR_BAGS.put(HumanArmorShape.LEGS,
+                new ArmorBag<>(HumanArmorShape.LEGS)
+                        .addEntry(null, 100, 1.0f)
+                        .addEntry(Items.ARMOR_LEGGINGS_LEATHER, 30, 0.8f)
+                        .addEntry(Items.ARMOR_LEGGINGS_IRON, 10, 0.5f)
+                        .addEntry(Items.ARMOR_LEGGINGS_DIAMOND, 5, 0.125f)
+                        .addEntry(Items.ARMOR_LEGGINGS_STEEL, 1, 0.125f));
+        ZOMBIE_ARMOR_BAGS.put(HumanArmorShape.BOOTS,
+                new ArmorBag<>(HumanArmorShape.BOOTS)
+                        .addEntry(null, 100, 1.0f)
+                        .addEntry(Items.ARMOR_BOOTS_LEATHER, 30, 0.8f)
+                        .addEntry(Items.ARMOR_BOOTS_IRON, 10, 0.5f)
+                        .addEntry(Items.ARMOR_BOOTS_DIAMOND, 5, 0.125f)
+                        .addEntry(Items.ARMOR_BOOTS_STEEL, 1, 0.125f));
+    }
+
+    public static final @NotNull HashMap<@NotNull HumanArmorShape, @NotNull ArmorBag<@NotNull HumanArmorShape>> SKELETON_ARMOR_BAGS = register(MobSkeleton.class, new HashMap<>());
+    static {
+        SKELETON_ARMOR_BAGS.put(HumanArmorShape.HEAD,
+                new ArmorBag<>(HumanArmorShape.HEAD)
+                        .addEntry(null, 100, 1.0f)
+                        .addEntry(Items.ARMOR_HELMET_LEATHER, 30, 0.8f)
+                        .addEntry(Items.ARMOR_HELMET_IRON, 10, 0.5f)
+                        .addEntry(Items.ARMOR_HELMET_DIAMOND, 5, 0.125f)
+                        .addEntry(Items.ARMOR_HELMET_STEEL, 1, 0.125f));
+        SKELETON_ARMOR_BAGS.put(HumanArmorShape.CHEST,
+                new ArmorBag<>(HumanArmorShape.CHEST)
+                        .addEntry(null, 100, 1.0f)
+                        .addEntry(Items.ARMOR_CHESTPLATE_LEATHER, 30, 0.8f)
+                        .addEntry(Items.ARMOR_CHESTPLATE_IRON, 10, 0.5f)
+                        .addEntry(Items.ARMOR_CHESTPLATE_DIAMOND, 5, 0.125f)
+                        .addEntry(Items.ARMOR_CHESTPLATE_STEEL, 1, 0.125f));
+        SKELETON_ARMOR_BAGS.put(HumanArmorShape.LEGS,
+                new ArmorBag<>(HumanArmorShape.LEGS)
+                        .addEntry(null, 100, 1.0f)
+                        .addEntry(Items.ARMOR_LEGGINGS_LEATHER, 30, 0.8f)
+                        .addEntry(Items.ARMOR_LEGGINGS_IRON, 10, 0.5f)
+                        .addEntry(Items.ARMOR_LEGGINGS_DIAMOND, 5, 0.125f)
+                        .addEntry(Items.ARMOR_LEGGINGS_STEEL, 1, 0.125f));
+        SKELETON_ARMOR_BAGS.put(HumanArmorShape.BOOTS,
+                new ArmorBag<>(HumanArmorShape.BOOTS)
+                        .addEntry(null, 100, 1.0f)
+                        .addEntry(Items.ARMOR_BOOTS_LEATHER, 30, 0.8f)
+                        .addEntry(Items.ARMOR_BOOTS_IRON, 10, 0.5f)
+                        .addEntry(Items.ARMOR_BOOTS_DIAMOND, 5, 0.125f)
+                        .addEntry(Items.ARMOR_BOOTS_STEEL, 1, 0.125f));
+    }
+
+    public static <S extends IArmorShape> @NotNull HashMap<@NotNull S, @NotNull ArmorBag<S>> register(final @NotNull Class<? extends MobMonsterArmored<S>> clazz, final @NotNull HashMap<@NotNull S, @NotNull ArmorBag<S>> armorBag) {
+        ARMOR_BAGS.put(clazz, (HashMap) armorBag);
+
+        return armorBag;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
index c5c1f6400..4be57e0d0 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
@@ -7,12 +7,16 @@ import com.mojang.nbt.tags.Tag;
 import net.minecraft.core.entity.IArmorWearing;
 import net.minecraft.core.entity.IItemHolding;
 import net.minecraft.core.enums.IArmorShape;
+import net.minecraft.core.item.ItemArmor;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.HashMap;
+import java.util.Random;
+
 public abstract class MobMonsterArmored<T extends IArmorShape>
     extends MobMonster
     implements IArmorWearing<T>, IItemHolding {
@@ -25,10 +29,37 @@ public abstract class MobMonsterArmored<T extends IArmorShape>
         super(world);
     }
 
+    /**
+     * Spawns one or more random armor pieces on the mob, with rarity based on height - lower mobs will be tougher
+     */
+    private void doRandomArmorSpawn(final @NotNull Random rand, final HashMap<?, ArmorBag<?>> armorBags) {
+        final int slots = this.getNumArmorSlots();
+        for (int i = 0; i < slots; i++) {
+            final @Nullable T slot = this.getArmorSlotByIndex(i);
+            if (slot != null && armorBags.containsKey(slot)) {
+                final @NotNull ArmorBag<?> armorBag = armorBags.get(slot);
+                if (armorBag.getArmorShape() != slot) {
+                    throw new RuntimeException("armorBags is malformed!");
+                }
+
+                final @Nullable ItemArmor<?> armor = armorBag.getRandomItem(rand, this.world.getHeightBlocks(), (int) Math.floor(this.y));
+                if (armor != null) {
+                    final @NotNull ItemStack armorStack = new ItemStack(armor);
+                    this.setItemInArmorSlot(slot, armorStack);
+                }
+            }
+        }
+    }
+
     @Override
     public void spawnInit() {
         super.spawnInit();
         setSharedFlag(FLAG_LEFT_HANDED, this.random.nextInt(10) == 0);
+
+        if (ArmorBags.ARMOR_BAGS.containsKey(this.getClass())) {
+            final HashMap<?, ArmorBag<?>> armorBags = ArmorBags.ARMOR_BAGS.get(this.getClass());
+            this.doRandomArmorSpawn(this.world.rand, armorBags);
+        }
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
index 2c5b60abe..028c70296 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
@@ -10,6 +10,8 @@ import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.HashMap;
+
 public class MobZombie extends MobMonsterArmored<HumanArmorShape>
 {
     public MobZombie(final @NotNull World world) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 2a0280a1b..8d227861f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -469,7 +469,7 @@ public abstract class Player
     private void collideWithPlayer(Entity entity)
     {
         entity.playerTouch(this);
-        addStat(StatList.mobEncounterStats.get(EntityDispatcher.idForClass(entity.getClass())), 1);
+        addStat(StatList.mobEncounterStats.get(entity.getDispatcherId()), 1);
     }
 
     public int getScore()
@@ -988,7 +988,7 @@ public abstract class Player
         }
         addStat(StatList.damageTakenStat, damage);
         if (attacker != null) {
-            addStat(StatList.mobEncounterStats.get(EntityDispatcher.idForClass(attacker.getClass())), 1);
+            addStat(StatList.mobEncounterStats.get(attacker.getDispatcherId()), 1);
         }
 
         return super.hurt(attacker, damage, type);
@@ -1180,7 +1180,7 @@ public abstract class Player
                 addStat(StatList.damageDealtStat, i);
             }
         }
-        addStat(StatList.mobEncounterStats.get(EntityDispatcher.idForClass(entity.getClass())), 1);
+        addStat(StatList.mobEncounterStats.get(entity.getDispatcherId()), 1);
     }
 
     public void respawnPlayer()
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
index 18a402a33..1ee476b3e 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
@@ -52,7 +52,7 @@ public class ItemWandSpawner extends Item implements IDispensable
         return id;
     }
     public void spawnEntity(ItemStack itemStack, World world, double x, double y, double z){
-        Entity entity = EntityDispatcher.createEntityInWorld(getEntityId(itemStack), world);
+        Entity entity = EntityDispatcher.getInstance().createEntityInWorld(getEntityId(itemStack), world);
         if (entity != null){
             entity.setPos(x, y, z);
             entity.spawnInit();
diff --git a/game/core/src/main/java/net/minecraft/core/lang/I18n.java b/game/core/src/main/java/net/minecraft/core/lang/I18n.java
index 1358620a9..0ed43a171 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/I18n.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/I18n.java
@@ -23,7 +23,8 @@ public class I18n {
         INSTANCE = new I18n(languageCode);
     }
 
-    public static @Nullable I18n getInstance() {
+    public static @NotNull I18n getInstance() {
+        assert INSTANCE != null : "I18n must be initialized before an instance is valid!";
         return INSTANCE;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeEntitySummon.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeEntitySummon.java
index ceb3e209f..143e09f9e 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeEntitySummon.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeEntitySummon.java
@@ -37,9 +37,9 @@ public class ArgumentTypeEntitySummon implements ArgumentType<Class<? extends En
         }
         String string = builder.toString();
 
-        for (NamespaceID entityId : EntityDispatcher.idToClassMap.keySet()) {
-            if (CommandHelper.matchesNamespaceId(entityId, string)) {
-                return EntityDispatcher.classForId(entityId);
+        for (EntityDispatcher.EntityDispatcherEntry<?> entry : EntityDispatcher.getInstance().entries) {
+            if (CommandHelper.matchesNamespaceId(entry.namespaceID, string)) {
+                return entry.entityClass;
             }
         }
         throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.entity_summon.invalid_entity"));
@@ -48,8 +48,8 @@ public class ArgumentTypeEntitySummon implements ArgumentType<Class<? extends En
     @Override
     public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
         String remaining = builder.getRemaining().toLowerCase(Locale.ROOT);
-        for (NamespaceID entityId : EntityDispatcher.idToClassMap.keySet()) {
-            CommandHelper.getStringToSuggest(entityId.toString().toLowerCase(Locale.ROOT), remaining).ifPresent(builder::suggest);
+        for (EntityDispatcher.EntityDispatcherEntry<?> entry : EntityDispatcher.getInstance().entries) {
+            CommandHelper.getStringToSuggest(entry.stringID.toLowerCase(Locale.ROOT), remaining).ifPresent(builder::suggest);
         }
         return builder.buildFuture();
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandHeal.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandHeal.java
index de47f6969..58cf57ddb 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandHeal.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandHeal.java
@@ -29,14 +29,10 @@ public class CommandHeal implements CommandManager.CommandRegistry {
                                     int entitiesAffected = 0;
                                     for (Entity entity : entities) {
                                         if (entity instanceof Mob) {
-                                            int maxHealth = 20;
-                                            try {
-                                                maxHealth = ((Mob)entity.getClass().getConstructor(World.class).newInstance(c.getSource().getWorld())).getMaxHealth();
-                                            } catch (NoSuchMethodException | InvocationTargetException | InstantiationException | IllegalAccessException ignored) {
-                                            }
-                                            int originalHealth = ((Mob)entity).getHealth();
-                                            ((Mob)entity).setHealthRaw(MathHelper.clamp(((Mob)entity).getHealth() + amount, 0, maxHealth));
-                                            if (((Mob)entity).getHealth() != originalHealth) ++entitiesAffected;
+                                            Mob mob = (Mob)entity;
+                                            int originalHealth = mob.getHealth();
+                                            mob.setHealthRaw(MathHelper.clamp(mob.getHealth() + amount, 0, mob.getMaxHealth()));
+                                            if (mob.getHealth() != originalHealth) ++entitiesAffected;
                                         }
                                     }
                                     c.getSource().sendTranslatableMessage("command.commands.heal.success_" + (entitiesAffected == 1 ? "single" : "multiple"), entitiesAffected);
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandMobSpawning.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandMobSpawning.java
index edcb3581b..ea132ffa7 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandMobSpawning.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandMobSpawning.java
@@ -28,7 +28,7 @@ public class CommandMobSpawning implements CommandManager.CommandRegistry {
                 ArgumentBuilderLiteral.<CommandSource>literal("mobspawning")
                     .requires(CommandSource::hasAdmin)
                     .then(ArgumentBuilderLiteral.<CommandSource>literal("list").executes(c -> {
-                        Collection<NamespaceID> ids = EntityDispatcher.idToClassMap.keySet();
+                        Collection<NamespaceID> ids = EntityDispatcher.getInstance().idToEntryMap.keySet();
                         World world = c.getSource().getWorld();
                         SpawnerConfig config = world.getSpawnerConfig();
                         for (NamespaceID s : ids) {
@@ -46,7 +46,8 @@ public class CommandMobSpawning implements CommandManager.CommandRegistry {
                                     World world = c.getSource().getWorld();
                                     SpawnerConfig config = world.getSpawnerConfig();
 
-                                    NamespaceID mobId = EntityDispatcher.idForClass(c.getArgument("entity", Class.class));
+                                    EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(c.getArgument("entity", Class.class));
+                                    NamespaceID mobId = entry != null ? entry.namespaceID : null;
                                     boolean value = c.getArgument("value", Boolean.class);
                                     config.setMobSpawn(mobId, value);
                                     c.getSource().sendTranslatableMessage("command.commands.mobspawning.set", mobId, value);
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java
index de5bf0160..895f529c8 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.ArgumentBuilderLiteral;
 import com.mojang.brigadier.builder.ArgumentBuilderRequired;
 import com.mojang.brigadier.context.CommandContext;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
@@ -63,14 +64,12 @@ public class CommandSummon implements CommandManager.CommandRegistry {
     @SuppressWarnings({"SameParameterValue", "unchecked"})
     private static Entity summonEntityAt(CommandContext<CommandSource> c, double x, double y, double z, float yaw, float pitch) {
         Class<? extends Entity> entityClass = c.getArgument("entity", Class.class);
-        Entity entity;
-        try {
-            entity = entityClass.getConstructor(World.class).newInstance(c.getSource().getWorld());
-        } catch (Exception e) {
-            throw new RuntimeException(e);
+        Entity entity = EntityDispatcher.getInstance().createEntityInWorld(entityClass, c.getSource().getWorld());
+        if (entity == null) {
+            throw new RuntimeException("Could not create entity for '" + String.valueOf(entityClass) + "'");
         }
-        entity.spawnInit();
         entity.moveTo(x, y, z, yaw, pitch);
+        entity.spawnInit();
         c.getSource().getWorld().entityJoinedWorld(entity);
         return entity;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java
index 5bca2e9ec..0f11eb454 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java
@@ -115,7 +115,7 @@ public class EntitySelectorOptions {
                 }
                 CommandHelper.suggest("!Player", builder);
                 CommandHelper.suggest("Player", builder);
-                for (NamespaceID key : EntityDispatcher.idToClassMap.keySet()) {
+                for (NamespaceID key : EntityDispatcher.getInstance().idToEntryMap.keySet()) {
                     if (!(key.toString().startsWith(string) || (key.namespace().equals("minecraft") && key.value().startsWith(string)))) continue;
                     CommandHelper.suggest("!" + key, builder);
                     if (invert) continue;
@@ -148,10 +148,12 @@ public class EntitySelectorOptions {
             if (type.equals("Player")) {
                 parser.setLimitToType(Player.class);
             } else {
-                if (EntityDispatcher.classForId(type) != null) {
-                    parser.setLimitToType(EntityDispatcher.classForId(type));
-                } else if (EntityDispatcher.classForId("minecraft:" + type) != null) {
-                    parser.setLimitToType(EntityDispatcher.classForId("minecraft:" + type));
+                EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForId(type);
+                EntityDispatcher.EntityDispatcherEntry<?> entry2 = EntityDispatcher.getInstance().entryForId("minecraft:" + type);
+                if (entry != null) {
+                    parser.setLimitToType(entry.entityClass);
+                } else if (entry2 != null) {
+                    parser.setLimitToType(entry2.entityClass);
                 } else {
                     parser.getReader().setCursor(cursor);
                     throw UNKNOWN_ENTITY_TYPE.createWithContext(parser.getReader(), type);
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddMob.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddMob.java
index 0724cb7b7..3a9e44c1f 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddMob.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddMob.java
@@ -31,7 +31,7 @@ public class PacketAddMob extends Packet
     public PacketAddMob(Mob mob)
     {
         id = mob.id;
-        type = (short) EntityDispatcher.numericIdForClass(mob.getClass());
+        type = (short) EntityDispatcher.getInstance().entryForClass(mob.getClass()).numericID;
         x = MathHelper.floor(mob.x * 32D);
         y = MathHelper.floor(mob.y * 32D);
         z = MathHelper.floor(mob.z * 32D);
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketSetMobSpawner.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketSetMobSpawner.java
index 0f9784a70..ac4cf849f 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketSetMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketSetMobSpawner.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.net.handler.PacketHandler;
 import org.jetbrains.annotations.Nullable;
@@ -13,18 +12,18 @@ public class PacketSetMobSpawner extends Packet {
     public int xPosition;
     public int yPosition;
     public int zPosition;
-    public @Nullable Class<? extends Entity> entityClass;
+    public @Nullable EntityDispatcher.EntityDispatcherEntry<?> dispatcherEntry;
 
     public PacketSetMobSpawner() {
         isChunkDataPacket = true;
     }
 
-    public PacketSetMobSpawner(int x, int y, int z, @Nullable Class<? extends Entity> entityClass) {
+    public PacketSetMobSpawner(int x, int y, int z, @Nullable EntityDispatcher.EntityDispatcherEntry<?> dispatcherEntry) {
         isChunkDataPacket = true;
         this.xPosition = x;
         this.yPosition = y;
         this.zPosition = z;
-        this.entityClass = entityClass;
+        this.dispatcherEntry = dispatcherEntry;
     }
 
     @Override
@@ -34,9 +33,9 @@ public class PacketSetMobSpawner extends Packet {
         zPosition = dis.readInt();
         int type = dis.readShort() & 0xFFFF;
         if (type == 0xFFFF) {
-            entityClass = null;
+            dispatcherEntry = null;
         } else {
-            entityClass = EntityDispatcher.classForNumericId(type);
+            dispatcherEntry = EntityDispatcher.getInstance().entryForNumericId(type);
         }
     }
 
@@ -45,7 +44,11 @@ public class PacketSetMobSpawner extends Packet {
         dos.writeInt(xPosition);
         dos.writeShort(yPosition);
         dos.writeInt(zPosition);
-        dos.writeShort(entityClass == null ? 0xFFFF : EntityDispatcher.numericIdForClass(entityClass));
+        if (dispatcherEntry != null) {
+            dos.writeShort(dispatcherEntry.numericID);
+        } else {
+            dos.writeShort(0xFFFF);
+        }
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
index ec7b6ad36..5729f3a75 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.util.helper;
 
 
+import org.jetbrains.annotations.Nullable;
+
 public class MathHelper
 {
 
@@ -122,9 +124,9 @@ public class MathHelper
 		return MathHelper.lerp(val0, val1, index - index0);
 	}
 
-    public static boolean stringNullOrLengthZero(String s)
+    public static boolean stringNullOrLengthZero(@Nullable String s)
     {
-        return s == null || s.length() == 0;
+        return s == null || s.isEmpty();
     }
     public static int ceilInt(int num, int denom){
         return (int) Math.ceil(((float)num/denom));
diff --git a/game/core/src/main/java/net/minecraft/core/world/Explosion.java b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
index efaa9e170..e74c5c8be 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
@@ -4,6 +4,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.IArmorWearing;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
@@ -167,6 +168,10 @@ public class Explosion {
                 double d13 = (1.0D - d4) * d12;
                 entity.hurt(exploder, (int) (((d13 * d13 + d13) / 2D) * 8D * (double) explosionSize2 + 1.0D), DamageType.BLAST);
                 double flingForce = d13 * 2;
+                if (entity instanceof IArmorWearing) {
+                    float proc = 1 - (((IArmorWearing<?>) entity).getTotalProtectionAmount(DamageType.BLAST) / 2f);
+                    flingForce *= proc;
+                }
                 entity.fling(xComp * flingForce, yComp * flingForce, zComp * flingForce, 1);
             }
         }
